#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySummerPlanGoldenTouchCFG.h"
std::auto_ptr<M_ActivitySummerPlanGoldenTouchCFG> M_ActivitySummerPlanGoldenTouchCFG::msSingleton(nullptr);

int M_ActivitySummerPlanGoldenTouchCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySummerPlanGoldenTouchCFGData* M_ActivitySummerPlanGoldenTouchCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySummerPlanGoldenTouchCFGData>& M_ActivitySummerPlanGoldenTouchCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySummerPlanGoldenTouchCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySummerPlanGoldenTouchCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySummerPlanGoldenTouchCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mPro = element->IntAttribute("Pro");
		data.mCost = element->IntAttribute("Cost");
		data.mReward = element->IntAttribute("Reward");
		data.mShowPro = element->IntAttribute("ShowPro");
		data.mAddColdValue = element->IntAttribute("AddColdValue");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySummerPlanGoldenTouchCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySummerPlanGoldenTouchCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySummerPlanGoldenTouchCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySummerPlanGoldenTouchCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySummerPlanGoldenTouchCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "Pro", data.mPro);
		LuaCfgHelper::readInt(L, "Cost", data.mCost);
		LuaCfgHelper::readInt(L, "Reward", data.mReward);
		LuaCfgHelper::readInt(L, "ShowPro", data.mShowPro);
		LuaCfgHelper::readInt(L, "AddColdValue", data.mAddColdValue);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySummerPlanGoldenTouchCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySummerPlanGoldenTouchCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySummerPlanGoldenTouchCFG* M_ActivitySummerPlanGoldenTouchCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySummerPlanGoldenTouchCFG());
	}
	return msSingleton.get();
}

void M_ActivitySummerPlanGoldenTouchCFG::Release()
{
	msSingleton.reset(nullptr);
}
